Time to drop 69-language-selector-zh-??.conf?

Bug #1581151 reported by Gunnar Hjalmarsson on 2016-05-12
18
This bug affects 2 people
Affects Status Importance Assigned to Milestone
language-selector (Ubuntu)
Undecided
Gunnar Hjalmarsson

Bug Description

With the transition to Noto Sans CJK as default font for Chinese, we have established a fontconfig configuration for rendering Chinese under an *English* locale via these three files:

/etc/fonts/conf.avail/64-language-selector-prefer.conf

/etc/fonts/conf.avail/65-fonts-arphic-ukai.conf

/etc/fonts/conf.avail/65-fonts-arphic-uming.conf

(I questioned the need for the two latter in bug #1560548, but I think we'd better consider the need for the 69-language-selector-zh-??.conf files first.)

So, if I have understood the feedback from Chinese users correctly, both Chinese and Japanese are properly rendered under an English locale in Ubuntu 16.04.

It's my belief that what's happening if you switch to a Chinese locale is that one of the 69-language-selector-zh-??.conf files is enabled, and Japanese is no longer properly rendered while there is no improvement in rendering Chinese.

If I'm right, I think we should drop 69-language-selector-zh-??.conf. Did I miss anything?

Yuan Chao (yuanchao) wrote :

For Noto Sans font, it's just for the Sans Serif family. Still for Serif fonts, we still rely on other local font sets. The fallback settings in those fontconfig files should still be needed.

Japanese uses Chinese characters but with some variates. That's why a local font is preferred. Noto Sans provides all glyphs for different locale, which meets the needs. Just currently only Sans Serif is provided for Noto Sans.

Aron Xu (happyaron) wrote :

As said by yuanchao, we need to deal with Serif font faces, especially those commonly used commercial fonts like SimSun (which is free for personal use), and some other fonts that's easy to purchase.

Gunnar Hjalmarsson (gunnarhj) wrote :

fonts-noto-cjk also provides Noto Sans Mono, but not serif.

Ok, this attempt at simplifying things may be a "mission impossible". :-/ So we'll keep needing language specific font configuration for CJK, after all. Guess we have to live with the fact that no "perfect" configuration exists, which would deal with all the CJK languages simultaneously also for serif.

Closing this bug report. Thanks for your comments!

Changed in language-selector (Ubuntu):
status: New → Won't Fix
Gunnar Hjalmarsson (gunnarhj) wrote :

Since Noto now provides also Serif for CJK, I reopened this bug.

My questions are:

1. Since Serif fonts are included in fonts-noto-cjk and fonts-noto-cjk-extra, wouldn't it be a good idea to make Noto Serif be the first serif options in the /etc/fonts/conf.avail/69-language-selector-zh-??.conf files?

2. Should we keep pulling the fonts-arphic-* packages by default for Chinese users?

3. If we would make the changes in 1. and 2., are the /etc/fonts/conf.avail/69-language-selector-zh-??.conf files motivated at all?

Changed in language-selector (Ubuntu):
status: Won't Fix → New
Yuan Chao (yuanchao) wrote :

To me,
1. This is for sure to go. Noto serif has large glyph coverage and better font (hinting) quality. I think it should go first in the alias.
2. Some old software like adobe flash / youtube (flash must die...) has hard-coded font name in the program. I recall UMing and UKai do some tweaks to overcome this. Those settings need to be kept and migrate. Also some old software have hard time dealing with TTC or OTF/OCF, this needs test. (maybe it's time to get rid of them all... ;) )
3. I think "prepend" is still needed for fallback when using non-Noto fonts?

Gunnar Hjalmarsson (gunnarhj) wrote :

Thanks Yuan Chao. Then I'll make change #1 in the beginning of the 18.04 development cycle, so we have sufficient time to test.

As regards #2 it has to be evaluated by the Chinese user community. Let's keep pulling them for now.

On 2017-10-12 17:52, Yuan Chao wrote:
> 3. I think "prepend" is still needed for fallback when using
> non-Noto fonts?

I'm not sure of that. There is also the mechanism <prefer> - please see the beginning of the bug description. If you switch to an English locale, and are still able to use e.g. Uming, it would indicate that "prepend" isn't needed.

Changed in language-selector (Ubuntu):
assignee: nobody → Gunnar Hjalmarsson (gunnarhj)
status: New → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package language-selector - 0.182

---------------
language-selector (0.182) bionic; urgency=medium

  * data/pkg_depends:
    Pull Noto fonts for Japanese and Korean (LP: #1581160).
  * fontconfig/64-language-selector-prefer.conf:
    Add Korean fonts (LP: #1581160).
  * fontconfig/69-language-selector-ja.conf:
    New Japanese config file to control hinting etc. (LP: #1581160).
  * fontconfig/69-language-selector-zh-??.conf:
    Make Noto Serif CJK the preferred serif font (LP: #1581151).

 -- Gunnar Hjalmarsson <email address hidden> Thu, 02 Nov 2017 00:13:00 +0100

Changed in language-selector (Ubuntu):
status: Fix Committed → Fix Released
Gunnar Hjalmarsson (gunnarhj) wrote :

Ok, so now the preferred serif font for Chinese has been changed to "Noto Serif CJK {SC,TC}". Please test this, and report any related issues ASAP.

I let this bug report remain closed. Let's file new reports if and when it's considered motivated to deal with further changes of the default Chinese font configuration.

Gunnar Hjalmarsson (gunnarhj) wrote :

I have uploaded related changes to
/etc/fonts/conf.avail/30-cjk-aliases.conf:

http://launchpadlibrarian.net/345170169/language-selector_0.182_0.183.diff.gz

Would appreciate if someone for respective language, who understands the meaning of those aliases, could review the changes.

Changed in language-selector (Ubuntu):
status: Fix Released → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package language-selector - 0.183

---------------
language-selector (0.183) bionic; urgency=medium

  * fontconfig/30-cjk-aliases.conf:
    Complete with Noto fonts (LP: #1581160, LP: #1581151).

 -- Gunnar Hjalmarsson <email address hidden> Fri, 10 Nov 2017 02:38:00 +0100

Changed in language-selector (Ubuntu):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers